import ts from "typescript";
export declare class Codebase {
    readonly entryFilePath: string;
    readonly program: ts.Program;
    readonly host: ts.CompilerHost;
    readonly checker: ts.TypeChecker;
    protected sourceFiles: Map<string, ts.SourceFile>;
    protected updatedSourceFilePaths: Set<string>;
    protected transformedFilesMap: Map<string, {
        comment: string;
        content: string;
    }>;
    protected moduleSystem: "esm" | "commonjs";
    protected initializePromise?: Promise<void>;
    constructor({ entryFilePath, moduleSystem }: {
        entryFilePath: string;
        moduleSystem?: "esm" | "commonjs";
    });
    initialize(): Promise<this>;
    getSourceFile(filePath: string): ts.SourceFile | undefined;
    updateSourceFile(sourceFile: ts.SourceFile): ts.SourceFile;
    markSourceFileAsUpdated(sourceFile: ts.SourceFile): ts.SourceFile;
    getModifiedSourceFiles(): ts.SourceFile[];
    getRelativeImportPath(containingFilePath: string, importedFilePath: string): string;
    writeChangesToFilesystem(): string[];
    private _addHostReadFileMiddleware;
}
